summary refs log tree commit diff
path: root/fs/btrfs/version.sh
diff options
context:
space:
mode:
authorChris Mason <chris.mason@oracle.com>2008-11-19 15:59:28 -0500
committerChris Mason <chris.mason@oracle.com>2008-11-19 15:59:28 -0500
commitae20a6afec1cf21919d97303f2d8b737eac5acc7 (patch)
treea4ddf02d4f19bdee1119dcc8a0f54edb40fb5986 /fs/btrfs/version.sh
parent9bf1a2445f3c569098b8de7097ca324e65abecc2 (diff)
parent07103a3cdb24099324a11be1f35279b463cdfc31 (diff)
downloadlinux-ae20a6afec1cf21919d97303f2d8b737eac5acc7.tar.gz
Merge branch 'master' of git://git.kernel.org/pub/scm/linux/kernel/git/mason/btrfs-unstable
Diffstat (limited to 'fs/btrfs/version.sh')
-rw-r--r--fs/btrfs/version.sh43
1 files changed, 43 insertions, 0 deletions
diff --git a/fs/btrfs/version.sh b/fs/btrfs/version.sh
new file mode 100644
index 000000000000..0f57f24404d9
--- /dev/null
+++ b/fs/btrfs/version.sh
@@ -0,0 +1,43 @@
+#!/bin/bash
+#
+# determine-version -- report a useful version for releases
+#
+# Copyright 2008, Aron Griffis <agriffis@n01se.net>
+# Copyright 2008, Oracle
+# Released under the GNU GPLv2
+ 
+v="v0.16"
+
+which hg > /dev/null
+if [ -d .hg ] && [ $? == 0 ]; then
+	last=$(hg tags | grep -m1 -o '^v[0-9.]\+')
+	 
+	# now check if the repo has commits since then...
+	if [[ $(hg id -t) == $last || \
+	    $(hg di -r "$last:." | awk '/^diff/{print $NF}' | sort -u) == .hgtags ]]
+	then
+	    # check if it's dirty
+	    if [[ $(hg id | cut -d' ' -f1) == *+ ]]; then
+		v=$last+
+	    else
+		v=$last
+	    fi
+	else
+	    # includes dirty flag
+	    v=$last+$(hg id -i)
+	fi
+fi
+ 
+echo "#ifndef __BUILD_VERSION" > .build-version.h
+echo "#define __BUILD_VERSION" >> .build-version.h
+echo "#define BTRFS_BUILD_VERSION \"Btrfs $v\"" >> .build-version.h
+echo "#endif" >> .build-version.h
+
+diff -q version.h .build-version.h >& /dev/null
+
+if [ $? == 0 ]; then
+    rm .build-version.h
+    exit 0
+fi
+
+mv .build-version.h version.h